<!-- Main Area -->
<div class="main-content">
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header card-header-icon card-header-info">
                        <div class="card-icon">
                            <i class="material-icons">assignment</i>
                        </div>
                        <h4 class="card-title">Danh mục dịch vụ</h4>
                    </div>
                    <div class="card-body">
                        <form>
                            <button mat-raised-button type="submit" class="btn btn-primary pull-right"
                                (click)="search()">
                                Tìm kiếm
                            </button>
                            <button mat-raised-button class="btn btn-primary pull-right" data-toggle="modal"
                                data-target="#createCusService" (click)="onCreateMode()">
                                Thêm mới
                            </button>
                            <div class="clearfix"></div>
                        </form>

                        <div *ngIf="!showTable">Không có dữ liệu</div>

                        <div *ngIf="showTable">
                            <div class="table-responsive">
                                <table class="table">
                                    <thead class=" text-primary">
                                        <tr>
                                            <th> STT </th>
                                            <th> Mã dịch vụ </th>
                                            <th> Tên dịch vụ </th>
                                            <th> Đối tượng khách hàng </th>
                                            <th> Đường dẫn ảnh </th>
                                            <th> Hoạt động </th>
                                            <th> Visible </th>
                                            <th> Sử dụng </th>
                                            <th> Chức năng </th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr *ngFor="let row of cusService; let i = index">
                                            <td> {{i + 1}} </td>
                                            <td> {{row.svcCode}} </td>
                                            <td> {{row.svcName}} </td>
                                            <td> {{row.ctlCustomerObject !== null ? row.ctlCustomerObject.custName :''}} </td>
                                            <td> {{row.imageUrl}} </td>
                                            <td> {{row.isActive}} </td>
                                            <td> {{row.visibility}} </td>
                                            <td> {{row.isUsed}} </td>
                                            <td class="td-actions text-left">
                                                <button mat-raised-button type="button" class="btn btn-primary btn-link"
                                                    data-toggle="modal" data-target="#updateCusService"
                                                    (click)="onUpdateMode(row)">
                                                    <i class="material-icons">edit</i>
                                                </button>
                                                <button mat-raised-button type="button" class="btn btn-primary btn-link"
                                                    (click)="delete(row)">
                                                    <i class="material-icons">delete</i>
                                                </button>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>

                            <div class="row">
                                <div class="col-md-6">
                                    <div class="row">
                                        <label class="col-md-2 col-form-label">Số bản ghi tối đa </label>
                                        <mat-form-field class="example-full-width" style="width:40px">
                                            <mat-select matInput [(ngModel)]="limit" name="limit"
                                                (ngModelChange)="limitChange()">
                                                <mat-option [value]="10">10</mat-option>
                                                <mat-option [value]="20">20</mat-option>
                                                <mat-option [value]="50">50</mat-option>
                                                <mat-option [value]="100">100</mat-option>
                                            </mat-select>
                                        </mat-form-field>
                                    </div>
                                </div>

                                <div class="col-md-6">
                                    <ul class="pagination pull-right">
                                        <li class="page-item">
                                            <a mat-button class="page-link" aria-label="Previous"
                                                (click)="pageChange((page === 1) ? page : page - 1)">
                                                <span aria-hidden="true"><i class="fa fa-angle-double-left"
                                                        aria-hidden="true"></i></span>
                                            </a>
                                        </li>
                                        <li class="page-item">
                                            <a mat-button class="page-link" *ngIf="page !== 1"
                                                (click)="pageChange(1)">1</a>
                                        </li>
                                        <div *ngIf="page > 3">
                                            ...
                                        </div>
                                        <li class="page-item">
                                            <a mat-button class="page-link" *ngIf="page > 2"
                                                (click)="pageChange(page - 1)">{{page - 1}}</a>
                                        </li>
                                        <li class="page-item active">
                                            <a mat-button class="page-link" (click)="pageChange(page)">{{page}}</a>
                                        </li>
                                        <li class="page-item">
                                            <a mat-button class="page-link" *ngIf="page < end - 1"
                                                (click)="pageChange(page + 1)">{{page + 1}}</a>
                                        </li>
                                        <div *ngIf="page < end - 2">
                                            ...
                                        </div>
                                        <li class="page-item">
                                            <a mat-button class="page-link" *ngIf="page !== end"
                                                (click)="pageChange(end)">{{end}}</a>
                                        </li>
                                        <li class="page-item">
                                            <a mat-button class="page-link" aria-label="Next"
                                                (click)="pageChange((page * limit >= total) ? page : page + 1)">
                                                <span aria-hidden="true"><i class="fa fa-angle-double-right"
                                                        aria-hidden="true"></i></span>
                                            </a>
                                        </li>
                                    </ul>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<!-- Spinner Area -->
<app-spinner></app-spinner>

<!-- Modals Area -->
<div class="modal fade" id="createCusService" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Thêm mới dịch vụ</h4>
                <button mat-button type="button" class="close" data-dismiss="modal" aria-hidden="true"
                    id="createCusServiceClose">
                    <i class="material-icons">clear</i>
                </button>
            </div>
            <div class="modal-body">
                <p> Thêm mới dịch vụ theo các dữ liệu nhập vào. </p>

                <div class="form-group bmd-form-group is-filled">
                    <form>
                        <div class="row">
                            <div class="col-md-12">
                                <mat-form-field class="example-full-width">
                                    <input matInput [(ngModel)]="create_code_cus_service" name="create_code_cus_service"
                                        placeholder="Mã dịch vụ" [formControl]="create_code_cus_service_control" required>
                                    <mat-error *ngIf="create_code_cus_service_control.invalid">Thiếu mã dịch vụ</mat-error>
                                </mat-form-field>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <mat-form-field class="example-full-width">
                                    <input matInput [(ngModel)]="create_name_cus_service" name="create_name_cus_service"
                                        placeholder="Tên dịch vụ" [formControl]="create_name_cus_service_control" required>
                                    <mat-error *ngIf="create_name_cus_service_control.invalid">Thiếu tên dịch vụ</mat-error>
                                </mat-form-field>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <mat-form-field class="example-full-width">
                                    <mat-select matInput [(ngModel)]="create_cus_object" name="create_cus_object" placeholder="Đối tượng khách hàng" >
                                        <mat-option *ngFor="let row of cusObject" [value]="row.id">{{row.custName}}</mat-option>
                                    </mat-select>
                                </mat-form-field>
                            </div>
                            
                        </div>
                        <div class="row">
                            <div class="col-md-6">
                                <section class="example-section">
                                    <mat-checkbox class="example-margin" [(ngModel)]="create_is_active"
                                        name="create_is_active">Đang hoạt động</mat-checkbox>
                                </section>
                            </div>
                            <div class="col-md-6">
                                <section class="example-section">
                                    <mat-checkbox class="example-margin" [(ngModel)]="create_visibility"
                                        name="create_visibility">Visibility</mat-checkbox>
                                </section>
                            </div>
                        </div>
                        <hr>
                        <div class="childproduct">
                            <h4 class="modal-title">sản phẩm con</h4>
                            <div class="row">
                                <div class="col-md-10">
                                    <mat-form-field class="example-full-width">
                                        <mat-select matInput [(ngModel)]="create_child_service" name="create_child_service" placeholder="Mã sản phẩm" >
                                            <mat-option *ngFor="let row of productList" [value]="row.prdCode">{{row.prdName}}</mat-option>
                                        </mat-select>
                                    </mat-form-field>
                                </div>
                                <div class="col-md-2">
                                <button mat-raised-button="" type="submit" class="btn btn-white btn-round btn-just-icon" 
                                (click)="addChild()"><i class="material-icons">add</i><div class="ripple-container"></div></button>
                                </div>
                            </div>

                            <div class="table-responsive">
                                <table class="table">
                                    <thead class=" text-primary">
                                        <tr>
                                            <th> Mã sản phẩm </th>
                                            <th> Tên sản phẩm </th>
                                            <th> Bắt buộc </th>
                                            <th> Thứ tự </th>
                                            <th> Nhóm </th>
                                            <th> </th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr *ngFor="let row of childList; let i = index">
                                            <td> {{row.prdCode}} </td>
                                            <td> {{row.prdName}} </td>
                                            <td>
                                                <mat-checkbox class="example-margin" [(ngModel)]="create_compulsory_child" name="create_compulsory_child"></mat-checkbox>
                                            </td>
                                            <td>
                                                <mat-form-field class="example-full-width">
                                                <input type="number" matInput [(ngModel)]="create_order_child" name="create_order_child" placeholder="Thứ tự">
                                                </mat-form-field>
                                            </td>
                                            <td>
                                                <mat-checkbox class="example-margin" [(ngModel)]="create_group_child" name="create_group_child"></mat-checkbox>
                                            </td>
                                            <td class="td-actions text-left">
                                                <button mat-raised-button type="button" class="btn btn-primary btn-link"
                                                    (click)="deleteChild(row)">
                                                    <i class="material-icons">delete</i>
                                                </button>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                        <div class="clearfix"></div>
                    </form>
                </div>
            </div>
            <div class="modal-footer">
                <button mat-raised-button type="button" class="btn btn-primary btn-link" (click)="create()">Thêm
                    mới</button>
                <button mat-raised-button type="button" class="btn btn-danger btn-link"
                    data-dismiss="modal">Thoát</button>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="updateCusService" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Cập nhật dịch vụ</h4>
                <button mat-button type="button" class="close" data-dismiss="modal" aria-hidden="true"
                    id="updateCusServicesClose">
                    <i class="material-icons">clear</i>
                </button>
            </div>
            <div class="modal-body">
                <p> Cập nhật thông tin dịch vụ theo các dữ liệu nhập vào. </p>

                <div class="form-group bmd-form-group is-filled">
                    <form>
                        <div class="row">
                            <div class="col-md-12">
                                <mat-form-field class="example-full-width">
                                    <input matInput [(ngModel)]="update_code_cus_service" name="update_code_cus_service"
                                        placeholder="Tên dịch vụ" [formControl]="update_code_cus_service_control" required>
                                    <mat-error *ngIf="update_code_cus_service_control.invalid">Thiếu mã dịch vụ</mat-error>
                                </mat-form-field>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <mat-form-field class="example-full-width">
                                    <input matInput [(ngModel)]="update_name_cus_service" name="update_name_cus_service" placeholder="Tên dịch vụ"
                                        [formControl]="update_name_cus_service_control" required>
                                    <mat-error *ngIf="update_name_cus_service_control.invalid">Thiếu tên dịch vụ</mat-error>
                                </mat-form-field>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <mat-form-field class="example-full-width">
                                    <mat-select matInput [(ngModel)]="update_cus_object" name="update_cus_object" placeholder="Đối tượng khách hàng" >
                                        <mat-option *ngFor="let row of cusObject" [value]="row.id">{{row.custName}}</mat-option>
                                    </mat-select>
                                </mat-form-field>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-6">
                                <section class="example-section">
                                    <mat-checkbox class="example-margin" [(ngModel)]="update_is_active"
                                        name="update_is_active">Đang hoạt động</mat-checkbox>
                                </section>
                            </div>
                            <div class="col-md-6">
                                <section class="example-section">
                                    <mat-checkbox class="example-margin" [(ngModel)]="update_visible"
                                        name="update_visible">Visible</mat-checkbox>
                                </section>
                            </div>
                        </div>
                        <div class="childproduct">
                            <h4 class="modal-title">sản phẩm con</h4>
                            <div class="row">
                                <div class="col-md-10">
                                    <mat-form-field class="example-full-width">
                                        <mat-select matInput [(ngModel)]="update_child_service" name="update_child_service" placeholder="Mã sản phẩm" >
                                            <mat-option *ngFor="let row of productList" [value]="row.prdCode">{{row.prdName}}</mat-option>
                                        </mat-select>
                                    </mat-form-field>
                                </div>
                                <div class="col-md-2">
                                <button mat-raised-button="" type="submit" class="btn btn-white btn-round btn-just-icon" 
                                (click)="addChildUp()"><i class="material-icons">add</i><div class="ripple-container"></div></button>
                                </div>
                            </div>

                            <div class="table-responsive">
                                <table class="table">
                                    <thead class=" text-primary">
                                        <tr>
                                            <th> Mã sản phẩm </th>
                                            <th> Tên sản phẩm </th>
                                            <th> Bắt buộc </th>
                                            <th> Thứ tự </th>
                                            <th> Nhóm </th>
                                            <th> </th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr *ngFor="let row of childList; let i = index">
                                            <td>
                                                {{row.prdCode}}
                                            </td>
                                            <td> 
                                                {{row.prdName}}
                                            </td>
                                            <td>
                                                <section class="example-section">
                                                    <mat-checkbox class="example-margin" [(ngModel)]="row.isRequired"
                                                        name="{{row.id}}"></mat-checkbox>
                                                </section>
                                            </td>
                                            <td>
                                                <mat-form-field class="example-full-width">
                                                    <input type='number' matInput [(ngModel)]="row.sortOrder" name="{{row.id}}"
                                                        placeholder="Thứ tự">
                                                </mat-form-field>
                                            </td>
                                            <td>
                                                <section class="example-section">
                                                    <mat-checkbox class="example-margin" [(ngModel)]="row.viewGroup"
                                                        name="{{row.viewGroup}}"></mat-checkbox>
                                                </section>
                                            </td>
                                            <td class="td-actions text-left">
                                                <button mat-raised-button type="button" class="btn btn-primary btn-link"
                                                    (click)="deleteChild(row)">
                                                    <i class="material-icons">delete</i>
                                                </button>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                        <div class="clearfix"></div>
                    </form>
                </div>
            </div>
            <div class="modal-footer">
                <button mat-raised-button type="button" class="btn btn-primary btn-link" (click)="update()">Thay
                    đổi</button>
                <button mat-raised-button type="button" class="btn btn-danger btn-link"
                    data-dismiss="modal">Thoát</button>
            </div>
        </div>
    </div>
</div>